com.fasterxml.jackson.databind

## Class PropertyNamingStrategy

- java.lang.Object
- - com.fasterxml.jackson.databind.PropertyNamingStrategy

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  PropertyNamingStrategy.PropertyNamingStrategyBase

    public class PropertyNamingStrategy
    extends Object
    implements Serializable

Class that defines how names of JSON properties ("external names") are derived from names of POJO methods and fields ("internal names"), in cases where they are not auto-detected and no explicit annotations exist for naming. Methods are passed information about POJO member for which name is needed, as well as default name that would be used if no custom strategy was used.

Default (empty) implementation returns suggested ("default") name unmodified.

Note that the strategy is guaranteed to be called once per logical property (which may be represented by multiple members; such as pair of a getter and a setter), but may be called for each: implementations should not count on exact number of times, and should work for any member that represent a property.

In absence of a registered custom strategy, default Java property naming strategy is used, which leaves field names as is, and removes set/get/is prefix from methods (as well as lower-cases initial sequence of capitalized characters).

See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `PropertyNamingStrategy.KebabCaseStrategy` Naming strategy similar to `PropertyNamingStrategy.SnakeCaseStrategy`, but instead of underscores as separators, uses hyphens.
`static class` `PropertyNamingStrategy.LowerCaseStrategy` Simple strategy where external name simply only uses lower-case characters, and no separators.
`static class` `PropertyNamingStrategy.LowerCaseWithUnderscoresStrategy` Deprecated. In 2.7 use `PropertyNamingStrategy.SnakeCaseStrategy` instead
`static class` `PropertyNamingStrategy.LowerDotCaseStrategy` Naming strategy similar to `PropertyNamingStrategy.KebabCaseStrategy`, but instead of hyphens as separators, uses dots.
`static class` `PropertyNamingStrategy.PascalCaseStrategy` Deprecated. In 2.7 use `PropertyNamingStrategy.UpperCamelCaseStrategy` instead
`static class` `PropertyNamingStrategy.PropertyNamingStrategyBase`
`static class` `PropertyNamingStrategy.SnakeCaseStrategy` A `PropertyNamingStrategy` that translates typical camel case Java property names to lower case JSON element names, separated by underscores.
`static class` `PropertyNamingStrategy.UpperCamelCaseStrategy` A `PropertyNamingStrategy` that translates typical camelCase Java property names to PascalCase JSON element names (i.e., with a capital first letter).

### Field Summary

Fields
`static PropertyNamingStrategy` `CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES` Deprecated. Since 2.7 use `SNAKE_CASE` instead;
`static PropertyNamingStrategy` `KEBAB_CASE` Naming convention used in languages like Lisp, where words are in lower-case letters, separated by hyphens.
`static PropertyNamingStrategy` `LOWER_CAMEL_CASE` Naming convention used in Java, where words other than first are capitalized and no separator is used between words.
`static PropertyNamingStrategy` `LOWER_CASE` Naming convention in which all words of the logical name are in lower case, and no separator is used between words.
`static PropertyNamingStrategy` `LOWER_DOT_CASE` Naming convention widely used as configuration properties name, where words are in lower-case letters, separated by dots.
`static PropertyNamingStrategy` `PASCAL_CASE_TO_CAMEL_CASE` Deprecated. Since 2.7 use `UPPER_CAMEL_CASE` instead;
`static PropertyNamingStrategy` `SNAKE_CASE` Naming convention used in languages like C, where words are in lower-case letters, separated by underscores.
`static PropertyNamingStrategy` `UPPER_CAMEL_CASE` Naming convention used in languages like Pascal, where words are capitalized and no separator is used between words.

### Constructor Summary

Constructors
Constructor and Description
`PropertyNamingStrategy()`

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `nameForConstructorParameter(MapperConfig<?> config, AnnotatedParameter ctorParam, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given constructor parameter; typically called when building a deserializer (but not necessarily only then).
`String` `nameForField(MapperConfig<?> config, AnnotatedField field, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given field.
`String` `nameForGetterMethod(MapperConfig<?> config, AnnotatedMethod method, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given getter method; typically called when building a serializer.
`String` `nameForSetterMethod(MapperConfig<?> config, AnnotatedMethod method, String defaultName)` Method called to find external name (name used in JSON) for given logical POJO property, as defined by given setter method; typically called when building a deserializer (but not necessarily only then).

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### SNAKE_CASE

    public static final PropertyNamingStrategy SNAKE_CASE

Naming convention used in languages like C, where words are in lower-case letters, separated by underscores. See `PropertyNamingStrategy.SnakeCaseStrategy` for details.

Since:
  2.7 (was formerly called `CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES`)

#### UPPER_CAMEL_CASE

    public static final PropertyNamingStrategy UPPER_CAMEL_CASE

Naming convention used in languages like Pascal, where words are capitalized and no separator is used between words. See `PropertyNamingStrategy.PascalCaseStrategy` for details.

Since:
  2.7 (was formerly called `PASCAL_CASE_TO_CAMEL_CASE`)

#### LOWER_CAMEL_CASE

    public static final PropertyNamingStrategy LOWER_CAMEL_CASE

Naming convention used in Java, where words other than first are capitalized and no separator is used between words. Since this is the native Java naming convention, naming strategy will not do any transformation between names in data (JSON) and POJOS.

Since:
  2.7 (was formerly called `PASCAL_CASE_TO_CAMEL_CASE`)

#### LOWER_CASE

    public static final PropertyNamingStrategy LOWER_CASE

Naming convention in which all words of the logical name are in lower case, and no separator is used between words. See `PropertyNamingStrategy.LowerCaseStrategy` for details.

Since:
  2.4

#### KEBAB_CASE

    public static final PropertyNamingStrategy KEBAB_CASE

Naming convention used in languages like Lisp, where words are in lower-case letters, separated by hyphens. See `PropertyNamingStrategy.KebabCaseStrategy` for details.

Since:
  2.7

#### LOWER_DOT_CASE

    public static final PropertyNamingStrategy LOWER_DOT_CASE

Naming convention widely used as configuration properties name, where words are in lower-case letters, separated by dots. See `PropertyNamingStrategy.LowerDotCaseStrategy` for details.

Since:
  2.10

#### CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES

    @Deprecated
    public static final PropertyNamingStrategy CAMEL_CASE_TO_LOWER_CASE_WITH_UNDERSCORES

Deprecated. Since 2.7 use `SNAKE_CASE` instead;

#### PASCAL_CASE_TO_CAMEL_CASE

    @Deprecated
    public static final PropertyNamingStrategy PASCAL_CASE_TO_CAMEL_CASE

Deprecated. Since 2.7 use `UPPER_CAMEL_CASE` instead;

### Constructor Detail

#### PropertyNamingStrategy

    public PropertyNamingStrategy()

### Method Detail

#### nameForField

    public String nameForField(MapperConfig<?> config,
                               AnnotatedField field,
                               String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given field.

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `field` - Field used to access property
  `defaultName` - Default name that would be used for property in absence of custom strategy
Returns:
  Logical name to use for property that the field represents

#### nameForGetterMethod

    public String nameForGetterMethod(MapperConfig<?> config,
                                      AnnotatedMethod method,
                                      String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given getter method; typically called when building a serializer. (but not always -- when using "getter-as-setter", may be called during deserialization)

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `method` - Method used to access property.
  `defaultName` - Default name that would be used for property in absence of custom strategy
Returns:
  Logical name to use for property that the method represents

#### nameForSetterMethod

    public String nameForSetterMethod(MapperConfig<?> config,
                                      AnnotatedMethod method,
                                      String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given setter method; typically called when building a deserializer (but not necessarily only then).

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `method` - Method used to access property.
  `defaultName` - Default name that would be used for property in absence of custom strategy
Returns:
  Logical name to use for property that the method represents

#### nameForConstructorParameter

    public String nameForConstructorParameter(MapperConfig<?> config,
                                              AnnotatedParameter ctorParam,
                                              String defaultName)

Method called to find external name (name used in JSON) for given logical POJO property, as defined by given constructor parameter; typically called when building a deserializer (but not necessarily only then).

Parameters:
  `config` - Configuration in used: either `SerializationConfig` or `DeserializationConfig`, depending on whether method is called during serialization or deserialization
  `ctorParam` - Constructor parameter used to pass property.
  `defaultName` - Default name that would be used for property in absence of custom strategy